---
Name: flash-discover
Description: Detect which system firmware flash method to use.
Prerequisites:
  - hardware-tools-install
Templates:
  - Name: discover
    Contents: |
      #!/usr/bin/env bash

      {{ template "prelude.tmpl" . }}
      {{if eq (.Param "flash-method") "list" }}
        {{ if .ParamExists "flash-list" }}
      drpcli machines tasks add {{.Machine.UUID}} at 0 flash-list
        {{else}}
      echo "List install requested, but list not specified!"
      exit 1
       {{ end }}
      {{ else if and (eq (.Param "flash-method") "list-then-block") (.ParamExists "flash-list") }}
      drpcli machines tasks add {{.Machine.UUID}} at 0 flash-list
      {{ else }}
      mfgr="$(drpcli gohai |jq -r '.DMI | .System | .Manufacturer')"
      {{ if ( .ParamExists "flash-manufacturer-override" ) -}}
      old="$mfgr"
      mfgr="{{ .Param "flash-manufacturer-override" }}"
      echo ">>> WARNING: 'flash-manufacturer-override' forced to '$mfgr'."
      echo "              Overriding discovered value of '$old'."
      {{ end -}}

      [[ -z "$mfgr" ]] && echo ">>> WARNING:  Discovered Manufacturer has no value." || true

      case $mfgr in
          "Dell Inc.") drpcli machines tasks add {{.Machine.UUID}} at 0 dell-firmware-flash;;
          "HP"|"HPE") drpcli machines tasks add {{.Machine.UUID}} at 0 hpe-firmware-flash;;
          Lenovo) drpcli machines tasks add {{.Machine.UUID}} at 0 lenovo-firmware-flash;;
          # Cisco does not have flash vs. flash-list support.  Instead, you flash from their HUU Iso,
          # which contains everything in an approved flash bundle.  This requires enough extra setup
          # to just require using flexiflow to make it happen.
          Cisco*) echo "Cisco flash support is only available when using Flexiflow."
                  echo "Make sure you have the cisco-support content bundle installed, along with all its prerequisites."
                  exit 1;;
          *) echo "No idea how to flash for $mfgr";;
      esac
      {{ end }}
